﻿var Promise = require('promise');
var readJsonSync = require('read-json-sync');
var util = require('util');
var globalErrorHandler = require('./global-error-handler');

module.exports = function loadCfg(configFilePath) {
	var p = new Promise(function (resolve, reject) {
		var filePath = configFilePath || './sealights.json';
        try {
			var cfg = readJsonSync(filePath);
            resolve(cfg);
        }
        catch (e) {
            globalErrorHandler.setLastError(e, 'Configuration loading failed. File: "' +filePath +'", error: ');
            reject(e);
        }
    });
    return p;
};