var fs = require('fs');
var path = require("path");
var consoleFileLogger = require("../sl-logger.js").consoleFileLogger;
var sourceMap = require("source-map");
var globalErrorHandler = require('../global-error-handler');
var fileAndFolderUtils = require('../file-and-folder-utils');
var utils = require('../utils');
var SlJsInfra = require("sl-js-infra").SlJsInfra;
var SourceMapReader = SlJsInfra.SourceMapReader;


// TODO: refactor to normal module
function readSourceMaps(fullFilename, fileContent, logger) {
    var log = logger ? logger.child({
        methodName: "readSourceMaps"
    }) : consoleFileLogger("readSourceMaps");
    if (!fullFilename || !fileContent){
        log.warn("'fullFilename' and 'fileContent' cannot be null or empty");
        log.debug("fullFilename: '%s'", fullFilename);
        return null;
    };

    try {
        var reader = new SourceMapReader(fullFilename, logger);
        var sourceMapData = reader.readSourceMapData(fileContent);
        if (!sourceMapData) {
            return null;
        }
        var consumer = new sourceMap.SourceMapConsumer(sourceMapData);
        return consumer;
    }catch (e) {
        logger.warn("Failed while reading source map for '%s'", fullFilename);
        logger.warn(e);
        return null;
    }
}




function ActualFile(relativeFileName, fullFilename) {
    var content;
    this.getContent = function ActualFile$getContent() {
        if(!content) {
            content = fs.readFileSync(fullFilename, 'utf-8');
        }
        return content;
    }
    this.readSourceMaps = function ActualFile$readSourceMaps(logger) {
        return readSourceMaps(fullFilename, this.getContent(), logger);
    }
}
module.exports = ActualFile;
